/**
 * Basic node stored in AVL trees
 */

public class AvlNode {

  /**
   * The data in the node
   */
  protected Comparable element;

  /**
   * Left child
   */
  protected AvlNode    left;

  /**
   * Right child
   */
  protected AvlNode    right;

  /**
   * Height
   */
  protected int        height;


  //
  /**
   * Creates a new node without children.
   * @param theElement to insert.
   */
  AvlNode( Comparable theElement ){
    this( theElement, null, null );
    }

    /**
     * Creates a new node with children and heigth equals to zero
     * @param theElement the key of the node.
     * @param lt the left child.
     * @param rt the right child.
     */
    AvlNode( Comparable theElement, AvlNode lt, AvlNode rt ){
    element  = theElement;
    left     = lt;
    right    = rt;
    height   = 0;
    }



}